<?php

// This include file is used to monitor site access and bar access to ripping.
// As coded, it should be included in the begin.php file of a TNG revision 5.1.4 installation
// using the line  -> include($cms[tngpath] . "check_access.php");
// immediately after the include("config.php"); 
// 
// Customizations:
//   - check the user configurable values below
//   - check the robot index exclusions below
//
// Revision 1.0, Wed Aug 16, 2006
// Brian McFadyen

// The following parameters are user configurable.  The defaults worked for me.

	$access_table = "site_access";   // A new TNG table that will be automatically created
	$fastest_access = 1.0;       // seconds between accesses to be considered fast. 0.5 is faster than most indexers
	$rip_ban = 6;              // number of fast clicks without a reset before banned
	$rip_warn = 3;             // number of fast clicks without a reset before a warning
	$rip_reset = 4;            // fast click reset time in seconds
	$rip_ban_time = 60;        // ban time in seconds

	 $link = @mysql_connect($database_host, $database_username, $database_password);
   if( !($link && mysql_select_db($database_name))) exit;

  $therows = 0;	
	$remhost = getenv( "REMOTE_HOST" );
	if( !$remhost ) {
		$remhost = $HTTP_SERVER_VARS['REMOTE_HOST'];
		if( !$remhost ) {
			$remip = getenv("REMOTE_ADDR");
			if( !$remip ) $remip = $HTTP_SERVER_VARS['REMOTE_ADDR'];
			$remhost = @gethostbyaddr( $remip );
			if( !$remhost ) $remhost = $remip;
		}
	}
	
	// Determine the referer site and clean up the text so it's not so messy
	$referer = getenv('HTTP_REFERER'); 
	$referer = ereg_replace("&tree=.*","",$referer);
	$referer = str_replace("&&","&",$referer);
	$referer = str_replace("&amp;$","",$referer);
	$referer = str_replace($tngdomain,"..",$referer);
	
	// Create a time index for comparison later
	list($usec, $sec) = explode(" ", microtime());
  $utime = ((float)$usec + (float)$sec);


	if(!mysql_query("SELECT host_ip,host_name,hit_time,hit_count,hit_refer FROM " . $access_table)){
  	$dbw_query = "CREATE TABLE IF NOT EXISTS $access_table(host_ip VARCHAR(32) NOT NULL, PRIMARY KEY(host_ip), host_name VARCHAR(64), hit_time DOUBLE, hit_count INT DEFAULT 0, ripping INT DEFAULT 0, waiting INT DEFAULT 0,  total_rip INT DEFAULT 0, hit_warn INT DEFAULT 0, hit_ban INT DEFAULT 0, hit_refer VARCHAR(200))";
  	$therows = mysql_query($dbw_query);
  }
  $dbw_query = "SELECT * FROM " . $access_table . " WHERE host_ip=\"" . $remip ."\"";
  
  // is this a return visitor?
  if(mysql_num_rows($results = mysql_query($dbw_query)) > 0 ) {
  	  $row = mysql_fetch_array($results);
			$ripping = $row[ripping];
			$total = $row[total_rip];
			$waiting = $row[waiting];
			$hitwarn = $row[hit_warn];
			$hitban = $row[hit_ban];

			// reset the ban timer if time is up
			if(($utime-$row[hit_time]) > $rip_ban_time){
				$waiting = 0;
			}
			// reset the ripping timer if the time is up
			if(($utime-$row[hit_time]) > $rip_reset){
				$ripping = 0;
			}
			// is this access too fast since last visit?
			if(($utime-$row[hit_time]) < $fastest_access){
				$ripping += 1;
				$total += 1;
			}
			// if these accesses are too many, then set a ban waiting time
			if($ripping > $rip_ban) {
				$waiting = 1;
				$hitban += 1;
				$ripping = 0;
			}
			// if these accesses are too fast, then issue a warning
			if($ripping > $rip_warn) {
				$hitwarn += 1;
			}
			// don't ban valid indexers
			// -------------------------------------
			// This section may be customized for your personal preferences
			// -------------------------------------
			
			if (strpos($remhost,"google") !== false || 
				strpos($remhost,"msnbot") !== false || 
				strpos($remhost,"inktomi") !== false || 
				strpos($remhost,"gigablast") !== false ){
					$waiting = 0;
					$ripping = 0;
			}

	    $dbw_query = "UPDATE " . $access_table . " SET host_name=\"$remhost\",hit_count=" . ($row[hit_count]+1) . ",hit_time=" . $utime . ",ripping=" . $ripping . ",total_rip=" . $total . ",hit_warn=" . $hitwarn . ",hit_ban=" . $hitban . ", waiting=" . $waiting . ", hit_refer=\"$referer\" WHERE host_ip=\"$remip\"";
	    $results = mysql_query($dbw_query);
	    
	    // if visitor has been banned, display the banned page and exit
			if($waiting){
				@include("rip_ban.html");
	    	exit;
	    }
	    // if visitor is to be warned, display the warning and exit
			if($ripping > $rip_warn) {
				@include("rip_warning.html");
				exit;
			}
	}	else {
		
		// new visitor, add them to the database
    $dbw_query= "INSERT " . $access_table . " SET host_ip=\"$remip\", host_name=\"$remhost\", hit_time=$utime, hit_refer=\"$referer\"";
    $results = mysql_query($dbw_query);
	}
?>
